type Fluffy::Rule = Struct[{
  order => Integer,
  Optional[chain] => String,
  Optional[table] => Enum['filter', 'nat', 'mangle', 'raw', 'security'],
  Optional[action] => Enum['ACCEPT', 'DROP', 'REJECT', 'QUEUE', 'RETURN', 'DNAT', 'SNAT', 'LOG', 'MASQUERADE', 'REDIRECT', 'MARK', 'TCPMSS'],
  Optional[jump] => String,
  Optional[negate_protocol] => Boolean,
  Optional[protocol] => Variant[Fluffy::Protocols, Array[Fluffy::Protocols]],
  Optional[negate_icmp_type] => Boolean,
  Optional[icmp_type] => Enum['any', 'echo-reply', 'destination-unreachable', 'network-unreachable', 'host-unreachable', 'protocol-unreachable', 'port-unreachable', 'fragmentation-needed', 'source-route-failed', 'network-unknown', 'host-unknown', 'network-prohibited', 'host-prohibited', 'TOS-network-unreachable', 'TOS-host-unreachable', 'communication-prohibited', 'host-precedence-violation', 'precedence-cutoff', 'source-quench', 'redirect', 'network-redirect', 'host-redirect', 'TOS-network-redirect', 'TOS-host-redirect', 'echo-request', 'router-advertisement', 'router-solicitation', 'time-exceeded', 'ttl-zero-during-transit', 'ttl-zero-during-reassembly', 'parameter-problem', 'ip-header-bad', 'required-option-missing', 'timestamp-request', 'timestamp-reply', 'address-mask-request', 'address-mask-reply'],
  Optional[negate_tcp_flags] => Boolean,
  Optional[tcp_flags] => String,
  Optional[negate_ctstate] => Boolean,
  Optional[ctstate] => Variant[Fluffy::Rule::Conntrack_states, Array[Fluffy::Rule::Conntrack_states]],
  Optional[negate_state] => Boolean,
  Optional[state] => Variant[Fluffy::Rule::States, Array[Fluffy::Rule::States]],
  Optional[negate_src_address_range] => Boolean,
  Optional[src_address_range] => Variant[String, Array[String]],
  Optional[negate_dst_address_range] => Boolean,
  Optional[dst_address_range] => Variant[String, Array[String]],
  Optional[negate_in_interface] => Boolean,
  Optional[in_interface] => Variant[String, Array[String]],
  Optional[negate_out_interface] => Boolean,
  Optional[out_interface] => Variant[String, Array[String]],
  Optional[negate_src_address] => Boolean,
  Optional[src_address] => Variant[String, Array[String]],
  Optional[negate_dst_address] => Boolean,
  Optional[dst_address] => Variant[String, Array[String]],
  Optional[negate_src_service] => Boolean,
  Optional[src_service] => Variant[String, Array[String]],
  Optional[negate_dst_service] => Boolean,
  Optional[dst_service] => Variant[String, Array[String]],
  Optional[reject_with] => Enum['present', 'icmp-net-unreachable', 'icmp-host-unreachable', 'icmp-port-unreachable', 'icmp-proto-unreachable', 'icmp-net-prohibited', 'icmp-host-prohibited', 'icmp-admin-prohibited'],
  Optional[set_mss] => Integer[1],
  Optional[clamp_mss_to_pmtu] => Boolean,
  Optional[to_src] => String,
  Optional[to_dst] => String,
  Optional[limit] => String,
  Optional[limit_burst] => String,
  Optional[log_prefix] => String,
  Optional[log_level] => Enum['emerg', 'alert', 'crit', 'err', 'warning', 'notice', 'info', 'debug'],
  Optional[comment] => String,
  Optional[ensure] => Enum['present', 'absent']
}]
